/* Define to prevent recursive inclusion ------------------------------------*/
#ifndef __MOTOR_SVPWM_ADC2R_H
#define __MOTOR_SVPWM_ADC2R_H

/* Includes -----------------------------------------------------------------*/
#include "ch32v20x_conf.h"

/* Exported types -----------------------------------------------------------*/
/* Exported constants -------------------------------------------------------*/
//SVPWM
#define DCBUS_RATED_VOLT            _IQ18(24)   //ĸߵѹ(unit-V)

#define SYSTEM_CLOCK_FREQ           144000000uL //ϵͳʱƵ(unit-Hz)
#define TIMER_PRESCALER_SVPWM       1           //SVPWMʱԤƵϵ

//SVPWMʱʱƵ(unit-Hz)
#define TIMER_CLOCK_FREQ_SVPWM      (SYSTEM_CLOCK_FREQ/(TIMER_PRESCALER_SVPWM+1))

#define TIMER_UPDATE_RATE_SVPWM     1      //SVPWMʱʱ
#define FREQ_SVPWM                  20000  //SVPMWƵ(unit-Hz)

#define DEADTIME_SVPWM   500         //SVPWMʱ(unit-ns)

//ʱӦʱӸ
#define DEADTIME_CLOCK_SVPWM  (uint16_t)((DEADTIME_SVPWM*(SYSTEM_CLOCK_FREQ/1000000))/1000)

#define BRK_GPIO_M    GPIOB            //ͣ˿
#define BRK_PIN_M     GPIO_Pin_12      //ͣ˿

//ADC
#define CURR_SAMPLE_RESISTOR_ADC    _IQ18(0.1)   //
#define CURR_AMPLIFIER_ADC          _IQ18(3.03)  //ӲŴ

//Χ(ֵ,unit-A/per)
#define CURR_SAMPLE_RANGE_ADC       _IQ18div(_IQ18(1.65),_IQ18mpy(CURR_SAMPLE_RESISTOR_ADC,CURR_AMPLIFIER_ADC))

#define SAMPLING_TIMER_CLOCK   ADC_SampleTime_7Cycles5 //ADCתʱã20ʱ,Ӧ1666ns

#define INJ_CONVERT_LENGTH_ADC      0x00100000  //ADC עתг
#define CURR_OFFSET_READ_NUM_ADC    ((uint8_t)16)    //ƫü

//ͨ
#define CURR_CHANNEL_PHASEA_M         ADC_Channel_5
#define CURR_GPIO_GROUP_PHASEA_M      GPIOA
#define CURR_GPIO_PIN_PHASEA_M        GPIO_Pin_5

#define CURR_CHANNEL_PHASEB_M         ADC_Channel_4
#define CURR_GPIO_GROUP_PHASEB_M      GPIOA
#define CURR_GPIO_PIN_PHASEB_M        GPIO_Pin_4

//עתͨ
#define PHASE_A_JQ3     (uint32_t)((uint32_t)(CURR_CHANNEL_PHASEA_M) << 10)//õǿ3JSQ:3
#define PHASE_B_JQ4     (uint32_t)((uint32_t)(CURR_CHANNEL_PHASEB_M) << 15)//õǿ4JSQ:4

//ѹ
#define DCBUS_VOLT_AVER_INIT    _IQ18(1.0)      //ĸߵѹֵʼֵ
#define DCBUS_CONV_RATIO        _IQ18(0.06)  //ĸߵѹѹ
#define DCBUS_VOLT_AVER_SIZE    128             //ĸߵѹֵ

/* Exported variables -------------------------------------------------------*/
extern SVPWM_2R_Type            SVPWM_Cal_M;
extern ADC_Structure_Type       ADC_M;

/* Exported macro ------------------------------------------------------------*/

/* Exported functions ------------------------------------------------------- */
//SVPWMʼ
void SVPWM_Paramter_Init(SVPWM_2R_Type *SVPWM_Cal_Struc,_iq18 Vbase);

//SVPWM״̬ʼ
void SVPWM_Status_Initial_M(SVPWM_2R_Type *SVPWM_Cal_Struc,TIM_TypeDef *Timer);

//SVPWM
void SVPWM_Calculation (SVPWM_2R_Type *SVPWM_Cal, Component_2S_Type *VoltRef,TIM_TypeDef *Timer);

//ADC
void ADC_Parameter_Init (ADC_Structure_Type *ADCStruc,_iq18 Ibase);

//ADC״̬ʼ
void ADC_Status_Init (ADC_Structure_Type *ADCStruc,ADC_TypeDef *ADCx,TIM_TypeDef *Timer);

//SVPWMʹöʱã
void SVPWM_Timer_Configure(TIM_TypeDef *Timer);

//ADC
void ADC_Configure(ADC_Structure_Type *ADCStruc,ADC_TypeDef *ADCx,TIM_TypeDef *Timer);

//2ȡ
Component_3S_Type Current_Cal_2R(ADC_Structure_Type *ADCStruc,ADC_TypeDef *ADCx);

//ADƫȡ
void ADC_Offset_Reading(ADC_TypeDef *ADCnum, ADC_Structure_Type *ADCStruc);

//ADCת
void ADC_Start (FunctionalState cmd,ADC_TypeDef *ADCx);

//ADCʱ̼
void ADC_Trigger(SVPWM_2R_Type *SVPWM_Cal,ADC_TypeDef *ADCx,TIM_TypeDef *Timer);

//ĸߵѹ
void DCBUS_Volt_Cal(ADC_Structure_Type *ADCStruc,ADC_TypeDef *ADCx);

#endif
