/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"

/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/

/* Private functions --------------------------------------------------------*/
void TIM2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

/* Private variables --------------------------------------------------------*/
static uint16_t Speed_Sample_PID_CNT = SPEED_SAMPLE_PID_PERIOD;   //תٻPIDڽ
static uint16_t Aver_Speed_Cal_CNT = AVER_SPEED_CAL_PERIOD;      //ƽתټ

/* Variables ----------------------------------------------------------------*/
/******************************************************************************
* Function Name  : TIM4_IRQHandler
* Description    : תٻж.
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void TIM2_IRQHandler(void)
{
    //ƽתټ,ʱ0.5ms
    Aver_Speed_Cal_CNT--;
    Speed_Sample_PID_CNT --;

    if (Aver_Speed_Cal_CNT !=0)
    {
        ADC_SoftwareStartConvCmd(ADC1, ENABLE);//adcĸߵѹ
    }
    else
    {
        Aver_Speed_Cal_CNT = AVER_SPEED_CAL_PERIOD;//¸ֵ

        //HALL۲ƽתټ
        //ƽ
        HALL_Cal_M.Angspeed_Aver1 = AverValue_Cal(HALL_Cal_M.Angspeed_Inst,&HALL_SpeedBuffer_M[0],&HALL_SpeedBuffPara_M);
        // HALL۲۲תٿɿж
        if(HALL_Cal_M.DetectUpwindFlag==2)//ʱжתȶ
        {
            HALL_Status_M.Reliable =  Speed_Reliable_Verify(&HALL_SpeedBuffPara_M,&HALL_SpeedBuffer_M[0],\
                    HALL_Cal_M.Angspeed_Aver1,HALL_Status_M.VarianceThresh);
        }

        //ĸߵѹ,ѹǷѹж
        if((ADC1->STATR & ADC_FLAG_EOC) == ADC_FLAG_EOC)
        {
            DCBUS_Volt_Cal(&ADC_M,ADC1);
            DCBus_Protecion(ADC_M.DCVoltAver, &DCBusProtecion_M);
            if(DCBusProtecion_M.OverCnt > DCBusProtecion_M.OverCntThresh)
            {
                Protection_SetFault(DC_OVER_VOLT);//ĸ߹ѹ
                printf("DCBUUS OVER VOLTAGE=%d\r\n",1111);//λ
            }

            if(DCBusProtecion_M.UnderCnt > DCBusProtecion_M.UnderCntThresh)
            {
                Protection_SetFault(DC_UNDER_VOLT);//ĸǷѹ
                printf("DCBUUS UNDER VOLTAGE=%d\r\n",1111);//λ
            }
        }
    }

    //תȶжͻ·ڼ,ʱ0.5ms
    if (Speed_Sample_PID_CNT == 0 )
    {
        Speed_Sample_PID_CNT = SPEED_SAMPLE_PID_PERIOD;//¸ֵ

        switch(RunningStatus_M)
               {
                   case START:
                       break;

                   case RUN:
                       Speed_Ramp_Process(&SpeedRamp_M);//תٸб´

                       if(HALL_Cal_M.DetectUpwindFlag!=2)
                       {
                           if( HALL_Cal_M.Angspeed_Aver1>=(0.5*SpeedRamp_M.Preramp ))
                               {
                                   HALL_Cal_M.DetectUpwindFlag=2;
                               }
                       }
                       if(HALL_Cal_M.DetectUpwindFlag==2)//˳ʱжתȶ
                       {
                          //תȶж
                           Speed_Stable_Verify(&HALL_Status_M, HALL_Cal_M.Angspeed_Aver1);
                           if(HALL_Status_M.Stable==FALSE)
                           {
                               Protection_SetFault(SPEED_ABNORMAL_M);
                               printf("HALL_Status_M_Unstable=%d\r\n",1111);
                           }
                       }

                       Motor_Stall_Verify2(SpeedRamp_M.Aftramp, HALL_Cal_M.Angspeed_Aver1, StatCurr2R_M.cq,&HALL_Status_M);
                       if(HALL_Status_M.Stall==TRUE)
                        {
                           Protection_SetFault(MOTOR_STALL_M);
                           printf("HALL_Status_M_Stall=%d\r\n",1111);
                        }

                       //תж
                       Motor_Reverse_Verify(SpeedRamp_M.Aftramp, HALL_Cal_M.Angspeed_Aver1, &HALL_Status_M);
                       if(HALL_Status_M.Reverse==TRUE)
                       {
                          Protection_SetFault(MOTOR_REVERSE_M);
                          printf("HALL_Status_M_Reverse=%d\r\n",1111);
                       }

                       if(HALL_Status_M.Hall_DefPhase==TRUE)
                      {
                         Protection_SetFault(MOTOR_HALL_DEFPHASE_M);
                         printf("MOTOR_HALL_DEFPHASE_M=%d\r\n",1111);
                      }


                       //תٻ
                       StatCurrRef2R_M.cq = PID_Calculaion (SpeedRamp_M.Aftramp,HALL_Cal_M.Angspeed_Aver1, &SpeedRegStruc_M);
                       //dл
                       StatCurrRef2R_M.cd = Dcurr_Process(&DCurrProcess_M, HALL_Cal_M.Angspeed_Aver1,StatCurrRef2R_M.cd);

                       break;
                   case BRAKE:
                           if( HALL_Cal_M.DetectUpwindFlag==1&&HALL_Cal_M.Brake_Judg_stop_Flag==1)
                           {
                               if( HALL_Status_M.Timeout == TRUE)
                               {
                                   HALL_Cal_M.Flystar_Timer_Overflow_Cnt++;
                               }
                           }
                           break;
               default:
                       break;
               }
    }

    TIM_ClearITPendingBit( TIM2, TIM_IT_Update);//жϱ־λ
}

/*******************************************************************************
* Function Name  : Timer2_Init
* Description    : ʱʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Timer2_Init(void)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseInitStructure;

    //ʹAPB1TIM4ʱ
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_TIM2, ENABLE );

    //18ƵʱΪ144MHz
    TIM_TimeBaseInitStructure.TIM_Prescaler = TIMER_PRESCALER_SPEED_LOOP;

    //ֵΪ4000ӦΪ0.5ms
    TIM_TimeBaseInitStructure.TIM_Period = TIMER_PERIDO_SPEED_LOOP_u16-1;

    //CKDƵ
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;

    //ģʽ
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;

    //Ĵʵ
    TIM_TimeBaseInit( TIM2, &TIM_TimeBaseInitStructure);
}
