/* Includes -----------------------------------------------------------------*/
#include "M0_Control_Library.h"
/* Private typedef ----------------------------------------------------------*/
/* Private define -----------------------------------------------------------*/
/* Private macro ------------------------------------------------------------*/
/* Private functions --------------------------------------------------------*/
void TIM1_UP_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM1_BRK_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void NMI_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void HardFault_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void Waveform_Display (void);//ʾ

/* Private variables --------------------------------------------------------*/
/* Variables ----------------------------------------------------------------*/

/******************************************************************************
* Function Name  : Interrupt_Configuration
* Description    : жȼ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void Interrupt_Configuration(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);             //жȼ

    //ADCעж
    NVIC_InitStructure.NVIC_IRQChannel = ADC_IRQn;              //жͨADC_IRQn
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;   //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;          //ȼ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;             //жʹ
    NVIC_Init(&NVIC_InitStructure);                             //üĴʵ

    //Timer1ж
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;          //жͨTIM1_UP_IRQn
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;   //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;          //ȼ2
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;             //жʹ
    NVIC_Init(&NVIC_InitStructure);                             //üĴʵ


    NVIC_InitStructure.NVIC_IRQChannel = TIM1_BRK_IRQn;         //жͨTIM1_BRK_IRQn
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;   //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;          //ȼ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;             //жʹ
    NVIC_Init(&NVIC_InitStructure);                             //üĴʵ
    TIM_ClearITPendingBit(TIM1, TIM_IT_Break);                  //ɲжϱ־
    TIM_ITConfig(TIM1, TIM_IT_Break,ENABLE);                    //ʹɲж


    //Timer2ж
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;   //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;          //ȼΪ2
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    TIM_ClearITPendingBit(TIM2, TIM_IT_Update);                 //¼־
    TIM_ITConfig(TIM2,  TIM_IT_Update , ENABLE );               //ʹܸж
    TIM_SelectOutputTrigger(TIM2,TIM_TRGOSource_Update);

   //Timer3ж
    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;   //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;          //ȼΪ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    TIM_ClearITPendingBit(TIM3, TIM_IT_Update);                 //¼־
    TIM_ITConfig(TIM3,  TIM_IT_Update , ENABLE );               //ʹܸж
    TIM_SelectOutputTrigger(TIM3,TIM_TRGOSource_Update);

    //Timer4ж
    NVIC_InitStructure.NVIC_IRQChannel = TIM4_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;  //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;         //ȼΪ0
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    NVIC_InitStructure.NVIC_IRQChannel = USB_LP_CAN1_RX0_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;   //ռȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;          //ȼΪ1
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    NVIC_EnableIRQ(USB_LP_CAN1_RX0_IRQn);
}
/*******************************************************************************
* Function Name  : HALL_Timer_IRQHandler
* Description    : None
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void TIM4_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM4_IRQHandler(void)
{
    uint8_t Hall_State;
      if ( TIM_GetFlagStatus(TIM4, TIM_FLAG_Update) == RESET )//Ǹжϣж
    {
        Hall_State=((uint8_t)(GPIO_ReadInputData(GPIOB)>>6)) & HALL_GPIO_MSK;

        Hall_DefPhase_Vefify(Hall_State,&HALL_Cal_M,&HALL_Status_M,RunningStatus_M);//HALLȱж

        HALL_Direction_AngleCalibration(Hall_State,&HALL_Cal_M,&HALL_Status_M,&HALL_Para_M);//HALLźŶȡжǴ
        HALL_Speed_Cal(&HALL_Cal_M,&HALL_Status_M,(uint32_t)TIM_GetCapture1(TIM4));  //ȡ˴βֵ);//תټ

//        //ƽ
        HALL_SpeedBuffPara_M.Index++;
        if (HALL_SpeedBuffPara_M.Index == HALL_SpeedBuffPara_M.Length )
        {
            HALL_SpeedBuffPara_M.Index = 0;
        }
        HALL_SpeedBuffer_M[HALL_SpeedBuffPara_M.Index] = HALL_Cal_M.Angspeed_Inst;

        TIM_ClearFlag(TIM4, TIM_FLAG_CC1);//־
    }
    else
    {
        //ʱ
        HALL_Overflow_Process(&HALL_Cal_M,&HALL_Status_M,&(HALL_SpeedBuffer_M[0]),&HALL_SpeedBuffPara_M);
        TIM_ClearFlag(TIM4, TIM_FLAG_Update);//ʱ жϱ
    }
}
/******************************************************************************
* Function Name  : TIM1_UP_IRQHandler
* Description    : ʱ1жϣ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void TIM1_UP_IRQHandler(void)
{
    //¼жϱ־
    TIM_ClearFlag(TIM1, TIM_FLAG_Update);

    //ʾʾ
    if(sendUsbData.sendDataLen)
      Waveform_Display();
}

/******************************************************************************
* Function Name  : TIM1_BRK_IRQHandler
* Description    : ɲжϣλ
* Input          : None
* Output         : None
* Return         : None
******************************************************************************/
void TIM1_BRK_IRQHandler(void)
{
    Protection_SetFault(DC_OVER_CURR_HARD_M);

    printf("OVERCURRENT_HARWARE_M1=%d\r\n",1111);

    TIM_ClearITPendingBit(TIM1, TIM_IT_Break);
}

/*******************************************************************************
* Function Name  : NMI_Handler
* Description    : This function handles NMI exception.
* Input          : None
* Return         : None
*******************************************************************************/
void NMI_Handler(void)
{
}

/*******************************************************************************
* Function Name  : HardFault_Handler
* Description    : This function handles Hard Fault exception.
* Input          : None
* Return         : None
*******************************************************************************/
void HardFault_Handler(void)
{
  while (1)
  {
      ;
  }
}
